Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/DIA/diaharm.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/DIA/diaharm.F90	(revision 13661)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/OCE/DIA/diaharm.F90	(revision 13662)
@@ -24,5 +24,5 @@
    
    INTEGER, PARAMETER :: jpincomax    = 2.*jpmax_harmo
-   INTEGER, PARAMETER :: jpdimsparse  = jpincomax*300*24
+   INTEGER, PARAMETER :: jpdimsparse  = jpincomax*366*24*2 ! 30min for a 1yr-long run
 
    !                         !!** namelist variables **
@@ -35,14 +35,14 @@
    INTEGER , ALLOCATABLE, DIMENSION(:)       ::   name
    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   ana_temp
-   REAL(wp), ALLOCATABLE, DIMENSION(:)       ::   ana_freq, ut   , vt   , ft
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   out_eta , out_u, out_v
-
-   INTEGER ::   ninco, nsparse
+   REAL(wp), ALLOCATABLE, DIMENSION(:)       ::   ana_freq, ut, vt, ft
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   out_eta, out_u, out_v
+
+   INTEGER  ::   ninco, nsparse
+   REAL(wp) ::   z1_tmp3
    INTEGER ,       DIMENSION(jpdimsparse)         ::   njsparse, nisparse
    INTEGER , SAVE, DIMENSION(jpincomax)           ::   ipos1
    REAL(wp),       DIMENSION(jpdimsparse)         ::   valuesparse
-   REAL(wp),       DIMENSION(jpincomax)           ::   ztmp4 , ztmp7
+   REAL(wp),       DIMENSION(jpincomax)           ::   ztmp4 , ztmp7, z1_pivot
    REAL(wp), SAVE, DIMENSION(jpincomax,jpincomax) ::   ztmp3 , zpilier
-   REAL(wp), SAVE, DIMENSION(jpincomax)           ::   zpivot
 
    CHARACTER (LEN=4), DIMENSION(jpmax_harmo) ::   tname   ! Names of tidal constituents ('M2', 'K1',...)
@@ -76,5 +76,5 @@
          WRITE(numout,*)
          WRITE(numout,*) 'dia_harm_init: Tidal harmonic analysis initialization'
-         WRITE(numout,*) '~~~~~~~ '
+         WRITE(numout,*) '~~~~~~~~~~~~~ '
       ENDIF
       !
@@ -131,5 +131,5 @@
          ENDIF
 
-         ALLOCATE(name    (nb_ana))
+         ALLOCATE(name(nb_ana))
          DO jh=1,nb_ana
             DO ji=1,jpmax_harmo
@@ -163,5 +163,5 @@
 
 
-   SUBROUTINE dia_harm ( kt )
+   SUBROUTINE dia_harm( kt )
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE dia_harm  ***
@@ -172,8 +172,8 @@
       !!
       !!--------------------------------------------------------------------
-      INTEGER, INTENT( IN ) :: kt
-      !
-      INTEGER  :: ji, jj, jh, jc, nhc
-      REAL(wp) :: ztime, ztemp
+      INTEGER, INTENT( in ) ::   kt
+      !
+      INTEGER  ::   ji, jj, jh, jc, nhc
+      REAL(wp) ::   ztime, ztemp
       !!--------------------------------------------------------------------
       IF( ln_timing )   CALL timing_start('dia_harm')
@@ -187,19 +187,16 @@
             DO jc = 1, 2
                nhc = nhc+1
-               ztemp =(     MOD(jc,2) * ft(jh) *COS(ana_freq(jh)*ztime + vt(jh) + ut(jh))  &
+               ztemp =  (   MOD(jc,2) * ft(jh) *COS(ana_freq(jh)*ztime + vt(jh) + ut(jh))  &
                   &    +(1.-MOD(jc,2))* ft(jh) *SIN(ana_freq(jh)*ztime + vt(jh) + ut(jh)))
                   !
-               DO jj = 1,jpj
-                  DO ji = 1,jpi
-                     ! Elevation
-                     ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1) + ztemp*sshn(ji,jj)*ssmask (ji,jj)        
-                     ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2) + ztemp*un_b(ji,jj)*ssumask(ji,jj)
-                     ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3) + ztemp*vn_b(ji,jj)*ssvmask(ji,jj)
+               DO jj = 2, jpjm1
+                  DO ji = 2, jpim1
+                     ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1) + ztemp * sshn(ji,jj) * ssmask (ji,jj) ! elevation      
+                     ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2) + ztemp * un_b(ji,jj) * ssumask(ji,jj) ! u-vel
+                     ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3) + ztemp * vn_b(ji,jj) * ssvmask(ji,jj) ! v-vel
                   END DO
                END DO
-               !
-            END DO
-         END DO
-         !       
+            END DO
+         END DO
       END IF
       !
@@ -220,19 +217,20 @@
       !!
       !!--------------------------------------------------------------------
-      INTEGER :: ji, jj, jh, jc, jn, nhan, jl
-      INTEGER :: ksp, kun, keq
-      REAL(wp) :: ztime, ztime_ini, ztime_end
-      REAL(wp) :: X1, X2
-      REAL(wp), DIMENSION(jpi,jpj,jpmax_harmo,2) ::   ana_amp   ! workspace
+      INTEGER  ::   ji, jj, jh, jc, jn, nhan
+      INTEGER  ::   ksp, kun, keq
+      REAL(wp) ::   ztime, ztime_ini, ztime_end, z1_han
       !!--------------------------------------------------------------------
       !
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'anharmo_end: kt=nitend_han: Perform harmonic analysis'
+      IF(lwp) WRITE(numout,*) 'dia_harm_end: kt=nitend_han: Perform harmonic analysis'
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+      
+      ALLOCATE( out_eta(jpi,jpj,2*nb_ana), out_u(jpi,jpj,2*nb_ana), out_v(jpi,jpj,2*nb_ana) )
 
       ztime_ini = nit000_han*rdt                 ! Initial time in seconds at the beginning of analysis
       ztime_end = nitend_han*rdt                 ! Final time in seconds at the end of analysis
       nhan = (nitend_han-nit000_han+1)/nstep_han ! Number of dumps used for analysis
-
+      z1_han = 1._wp / REAL(nhan-1) 
+      
       ninco = 2*nb_ana
 
@@ -240,5 +238,5 @@
       keq = 0        
       DO jn = 1, nhan
-         ztime=( (nhan-jn)*ztime_ini + (jn-1)*ztime_end )/FLOAT(nhan-1)
+         ztime=( (nhan-jn)*ztime_ini + (jn-1)*ztime_end ) * z1_han
          keq = keq + 1
          kun = 0
@@ -257,37 +255,21 @@
       nsparse = ksp
 
+      IF( nsparse > jpdimsparse )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : nsparse .GT. jpdimsparse')
+      IF( ninco   > jpincomax   )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : ninco .GT. jpincomax')
+
+      CALL SUR_DETERMINE_INIT
+
       ! Elevation:
-      DO jj = 1, jpj
-         DO ji = 1, jpi
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+
             ! Fill input array
-            kun = 0
-            DO jh = 1, nb_ana
-               DO jc = 1, 2
-                  kun = kun + 1
-                  ztmp4(kun)=ana_temp(ji,jj,kun,1)
-               END DO
-            END DO
-
-            CALL SUR_DETERMINE(jj)
-
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,1)
+            CALL SUR_DETERMINE
+            
             ! Fill output array
             DO jh = 1, nb_ana
-               ana_amp(ji,jj,jh,1)=ztmp7((jh-1)*2+1)
-               ana_amp(ji,jj,jh,2)=ztmp7((jh-1)*2+2)
-            END DO
-         END DO
-      END DO
-
-      ALLOCATE( out_eta(jpi,jpj,2*nb_ana),   & 
-         &      out_u  (jpi,jpj,2*nb_ana),   &
-         &      out_v  (jpi,jpj,2*nb_ana)  )
-
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            DO jh = 1, nb_ana 
-               X1 = ana_amp(ji,jj,jh,1)
-               X2 =-ana_amp(ji,jj,jh,2)
-               out_eta(ji,jj,jh       ) = X1 * tmask_i(ji,jj)
-               out_eta(ji,jj,jh+nb_ana) = X2 * tmask_i(ji,jj)
+               out_eta(ji,jj,jh       ) =  ztmp7((jh-1)*2+1) * ssmask(ji,jj)
+               out_eta(ji,jj,jh+nb_ana) = -ztmp7((jh-1)*2+2) * ssmask(ji,jj)
             END DO
          END DO
@@ -295,72 +277,44 @@
 
       ! ubar:
-      DO jj = 1, jpj
-         DO ji = 1, jpi
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+
             ! Fill input array
-            kun=0
-            DO jh = 1,nb_ana
-               DO jc = 1,2
-                  kun = kun + 1
-                  ztmp4(kun)=ana_temp(ji,jj,kun,2)
-               END DO
-            END DO
-
-            CALL SUR_DETERMINE(jj+1)
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,2)
+            CALL SUR_DETERMINE
 
             ! Fill output array
             DO jh = 1, nb_ana
-               ana_amp(ji,jj,jh,1) = ztmp7((jh-1)*2+1)
-               ana_amp(ji,jj,jh,2) = ztmp7((jh-1)*2+2)
-            END DO
-
-         END DO
-      END DO
-
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            DO jh = 1, nb_ana 
-               X1= ana_amp(ji,jj,jh,1)
-               X2=-ana_amp(ji,jj,jh,2)
-               out_u(ji,jj,       jh) = X1 * ssumask(ji,jj)
-               out_u(ji,jj,nb_ana+jh) = X2 * ssumask(ji,jj)
-            ENDDO
-         ENDDO
-      ENDDO
+               out_u(ji,jj,       jh) =  ztmp7((jh-1)*2+1) * ssumask(ji,jj)
+               out_u(ji,jj,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssumask(ji,jj)
+            END DO
+
+        END DO
+      END DO
 
       ! vbar:
-      DO jj = 1, jpj
-         DO ji = 1, jpi
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+
             ! Fill input array
-            kun=0
-            DO jh = 1,nb_ana
-               DO jc = 1,2
-                  kun = kun + 1
-                  ztmp4(kun)=ana_temp(ji,jj,kun,3)
-               END DO
-            END DO
-
-            CALL SUR_DETERMINE(jj+1)
+            ztmp4(1:nb_ana*2) = ana_temp(ji,jj,1:nb_ana*2,3)
+            CALL SUR_DETERMINE
 
             ! Fill output array
             DO jh = 1, nb_ana
-               ana_amp(ji,jj,jh,1)=ztmp7((jh-1)*2+1)
-               ana_amp(ji,jj,jh,2)=ztmp7((jh-1)*2+2)
-            END DO
-
-         END DO
-      END DO
-
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            DO jh = 1, nb_ana 
-               X1=ana_amp(ji,jj,jh,1)
-               X2=-ana_amp(ji,jj,jh,2)
-               out_v(ji,jj,       jh)=X1 * ssvmask(ji,jj)
-               out_v(ji,jj,nb_ana+jh)=X2 * ssvmask(ji,jj)
-            END DO
-         END DO
-      END DO
+               out_v(ji,jj,       jh) =  ztmp7((jh-1)*2+1) * ssvmask(ji,jj)
+               out_v(ji,jj,nb_ana+jh) = -ztmp7((jh-1)*2+2) * ssvmask(ji,jj)
+            END DO
+
+         END DO
+      END DO
+      !
+      ! clem: we could avoid this call if all the loops were from 1:jpi and 1:jpj
+      !       but I think this is the most efficient
+      CALL lbc_lnk_multi( 'dia_harm_end', out_eta, 'T', 1., out_u, 'U', -1. , out_v, 'V', -1. )
       !
       CALL dia_wri_harm ! Write results in files
+      !
+      DEALLOCATE( out_eta, out_u, out_v )
       !
    END SUBROUTINE dia_harm_end
@@ -373,9 +327,4 @@
       !! ** Purpose : Write tidal harmonic analysis results in a netcdf file
       !!--------------------------------------------------------------------
-      CHARACTER(LEN=lc) :: cltext
-      CHARACTER(LEN=lc) ::   &
-         cdfile_name_T   ,   & ! name of the file created (T-points)
-         cdfile_name_U   ,   & ! name of the file created (U-points)
-         cdfile_name_V         ! name of the file created (V-points)
       INTEGER  ::   jh
       !!----------------------------------------------------------------------
@@ -383,25 +332,22 @@
       IF(lwp) WRITE(numout,*) '  '
       IF(lwp) WRITE(numout,*) 'dia_wri_harm : Write harmonic analysis results'
-      IF(lwp) WRITE(numout,*) '  '
+      IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
 
       ! A) Elevation
       !/////////////
-      !
       DO jh = 1, nb_ana
       CALL iom_put( TRIM(tname(jh))//'x', out_eta(:,:,jh) )
-      CALL iom_put( TRIM(tname(jh))//'y', out_eta(:,:,nb_ana+jh) )
+      CALL iom_put( TRIM(tname(jh))//'y', out_eta(:,:,jh+nb_ana) )
       END DO
 
       ! B) ubar
       !/////////
-      !
       DO jh = 1, nb_ana
       CALL iom_put( TRIM(tname(jh))//'x_u', out_u(:,:,jh) )
-      CALL iom_put( TRIM(tname(jh))//'y_u', out_u(:,:,nb_ana+jh) )
+      CALL iom_put( TRIM(tname(jh))//'y_u', out_u(:,:,jh+nb_ana) )
       END DO
 
       ! C) vbar
       !/////////
-      !
       DO jh = 1, nb_ana
          CALL iom_put( TRIM(tname(jh))//'x_v', out_v(:,:,jh       ) )
@@ -412,84 +358,88 @@
 
 
-   SUBROUTINE SUR_DETERMINE(init)
+   SUBROUTINE SUR_DETERMINE_INIT
+      !!---------------------------------------------------------------------------------
+      !!                      *** ROUTINE SUR_DETERMINE_INIT ***
+      !!       
+      !!---------------------------------------------------------------------------------
+      INTEGER                        :: ji_sd, jj_sd, ji1_sd, ji2_sd, jh1_sd, jh2_sd
+      INTEGER                        :: ipivot
+      REAL(wp)                       :: zval1, zval2, zcol1, zcol2
+      INTEGER , DIMENSION(jpincomax) :: ipos2
+      !!---------------------------------------------------------------------------------
+      !            
+      !
+      ztmp3(:,:) = 0._wp
+      !
+      DO jh1_sd = 1, nsparse
+         DO jh2_sd = 1, nsparse
+            IF( nisparse(jh2_sd) == nisparse(jh1_sd) ) THEN
+               ztmp3(njsparse(jh1_sd),njsparse(jh2_sd)) = ztmp3(njsparse(jh1_sd),njsparse(jh2_sd))  &
+                  &                                     + valuesparse(jh1_sd)*valuesparse(jh2_sd)
+            ENDIF
+         END DO
+      END DO
+      !
+      DO jj_sd = 1, ninco
+         ipos1(jj_sd) = jj_sd
+         ipos2(jj_sd) = jj_sd
+      END DO
+      !
+      DO ji_sd = 1, ninco
+         !
+         !find greatest non-zero pivot:
+         zval1 = ABS(ztmp3(ji_sd,ji_sd))
+         !
+         ipivot = ji_sd
+         DO jj_sd = ji_sd, ninco
+            zval2 = ABS(ztmp3(ji_sd,jj_sd))
+            IF( zval2 >= zval1 )THEN
+               ipivot = jj_sd
+               zval1  = zval2
+            ENDIF
+         END DO
+         !
+         DO ji1_sd = 1, ninco
+            zcol1                = ztmp3(ji1_sd,ji_sd)
+            zcol2                = ztmp3(ji1_sd,ipivot)
+            ztmp3(ji1_sd,ji_sd)  = zcol2
+            ztmp3(ji1_sd,ipivot) = zcol1
+         END DO
+         !
+         ipos2(ji_sd)    = ipos1(ipivot)
+         ipos2(ipivot)   = ipos1(ji_sd)
+         ipos1(ji_sd)    = ipos2(ji_sd)
+         ipos1(ipivot)   = ipos2(ipivot)
+         z1_pivot(ji_sd) = 1._wp / ztmp3(ji_sd,ji_sd)
+         DO jj_sd = 1, ninco
+            ztmp3(ji_sd,jj_sd) = ztmp3(ji_sd,jj_sd) * z1_pivot(ji_sd)
+         END DO
+         !
+         DO ji2_sd = ji_sd+1, ninco
+            zpilier(ji2_sd,ji_sd) = ztmp3(ji2_sd,ji_sd)
+            DO jj_sd=1,ninco
+               ztmp3(ji2_sd,jj_sd) = ztmp3(ji2_sd,jj_sd) - ztmp3(ji_sd,jj_sd) * zpilier(ji2_sd,ji_sd)
+            END DO
+         END DO
+         !
+      END DO
+      !
+      z1_tmp3 = 1._wp / ztmp3(ninco,ninco)
+      !
+   END SUBROUTINE SUR_DETERMINE_INIT
+
+   
+   SUBROUTINE SUR_DETERMINE
       !!---------------------------------------------------------------------------------
       !!                      *** ROUTINE SUR_DETERMINE ***
       !!    
-      !!    
-      !!       
-      !!---------------------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   init 
-      !
-      INTEGER                         :: ji_sd, jj_sd, ji1_sd, ji2_sd, jh1_sd, jh2_sd
-      REAL(wp)                        :: zval1, zval2, zx1
-      REAL(wp), DIMENSION(jpincomax) :: ztmpx, zcol1, zcol2
-      INTEGER , DIMENSION(jpincomax) :: ipos2, ipivot
-      !---------------------------------------------------------------------------------
+      !!---------------------------------------------------------------------------------
+      INTEGER                        :: ji_sd, jj_sd, ji1_sd, ji2_sd
+      REAL(wp)                       :: zx1
+      REAL(wp), DIMENSION(jpincomax) :: ztmpx
+      !!---------------------------------------------------------------------------------
       !            
-      IF( init == 1 ) THEN
-         IF( nsparse > jpdimsparse )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : nsparse .GT. jpdimsparse')
-         IF( ninco   > jpincomax   )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : ninco .GT. jpincomax')
-         !
-         ztmp3(:,:) = 0._wp
-         !
-         DO jh1_sd = 1, nsparse
-            DO jh2_sd = 1, nsparse
-               nisparse(jh2_sd) = nisparse(jh2_sd)
-               njsparse(jh2_sd) = njsparse(jh2_sd)
-               IF( nisparse(jh2_sd) == nisparse(jh1_sd) ) THEN
-                  ztmp3(njsparse(jh1_sd),njsparse(jh2_sd)) = ztmp3(njsparse(jh1_sd),njsparse(jh2_sd))  &
-                     &                                     + valuesparse(jh1_sd)*valuesparse(jh2_sd)
-               ENDIF
-            END DO
-         END DO
-         !
-         DO jj_sd = 1 ,ninco
-            ipos1(jj_sd) = jj_sd
-            ipos2(jj_sd) = jj_sd
-         END DO
-         !
-         DO ji_sd = 1 , ninco
-            !
-            !find greatest non-zero pivot:
-            zval1 = ABS(ztmp3(ji_sd,ji_sd))
-            !
-            ipivot(ji_sd) = ji_sd
-            DO jj_sd = ji_sd, ninco
-               zval2 = ABS(ztmp3(ji_sd,jj_sd))
-               IF( zval2 >= zval1 )THEN
-                  ipivot(ji_sd) = jj_sd
-                  zval1         = zval2
-               ENDIF
-            END DO
-            !
-            DO ji1_sd = 1, ninco
-               zcol1(ji1_sd)               = ztmp3(ji1_sd,ji_sd)
-               zcol2(ji1_sd)               = ztmp3(ji1_sd,ipivot(ji_sd))
-               ztmp3(ji1_sd,ji_sd)         = zcol2(ji1_sd)
-               ztmp3(ji1_sd,ipivot(ji_sd)) = zcol1(ji1_sd)
-            END DO
-            !
-            ipos2(ji_sd)         = ipos1(ipivot(ji_sd))
-            ipos2(ipivot(ji_sd)) = ipos1(ji_sd)
-            ipos1(ji_sd)         = ipos2(ji_sd)
-            ipos1(ipivot(ji_sd)) = ipos2(ipivot(ji_sd))
-            zpivot(ji_sd)        = ztmp3(ji_sd,ji_sd)
-            DO jj_sd = 1, ninco
-               ztmp3(ji_sd,jj_sd) = ztmp3(ji_sd,jj_sd) / zpivot(ji_sd)
-            END DO
-            !
-            DO ji2_sd = ji_sd+1, ninco
-               zpilier(ji2_sd,ji_sd)=ztmp3(ji2_sd,ji_sd)
-               DO jj_sd=1,ninco
-                  ztmp3(ji2_sd,jj_sd)=  ztmp3(ji2_sd,jj_sd) - ztmp3(ji_sd,jj_sd) * zpilier(ji2_sd,ji_sd)
-               END DO
-            END DO
-            !
-         END DO
-         !
-      ENDIF ! End init==1
-
       DO ji_sd = 1, ninco
-         ztmp4(ji_sd) = ztmp4(ji_sd) / zpivot(ji_sd)
+         ztmp4(ji_sd) = ztmp4(ji_sd) * z1_pivot(ji_sd)
          DO ji2_sd = ji_sd+1, ninco
             ztmp4(ji2_sd) = ztmp4(ji2_sd) - ztmp4(ji_sd) * zpilier(ji2_sd,ji_sd)
@@ -498,6 +448,5 @@
 
       !system solving: 
-      ztmpx(ninco) = ztmp4(ninco) / ztmp3(ninco,ninco)
-      ji_sd = ninco
+      ztmpx(ninco) = ztmp4(ninco) * z1_tmp3
       DO ji_sd = ninco-1, 1, -1
          zx1 = 0._wp
@@ -505,13 +454,14 @@
             zx1 = zx1 + ztmpx(jj_sd) * ztmp3(ji_sd,jj_sd)
          END DO
-         ztmpx(ji_sd) = ztmp4(ji_sd)-zx1
-      END DO
-
-      DO jj_sd =1, ninco
-         ztmp7(ipos1(jj_sd))=ztmpx(jj_sd)
+         ztmpx(ji_sd) = ztmp4(ji_sd) - zx1
+      END DO
+
+      DO jj_sd = 1, ninco
+         ztmp7(ipos1(jj_sd)) = ztmpx(jj_sd)
       END DO
       !
    END SUBROUTINE SUR_DETERMINE
 
+   
    !!======================================================================
 END MODULE diaharm
